package com.banesco.module.service_order_payment_search.application.service;

import com.banesco.common.application.helper.MessageHelper;
import com.banesco.common.application.helper.RequestValidatorHelper;
import com.banesco.common.domain.exception.HttpStatusCodeException;
import com.banesco.common.domain.model.*;
import com.banesco.module.service_order_payment_search.application.usecase.BusinessUseCase;
import com.banesco.module.service_order_payment_search.application.usecase.ServiceOrderPaymentSearchUseCase;
import com.banesco.module.service_order_payment_search.domain.dto.request.ServiceOrderPaymentSearchRequest;
import com.banesco.module.service_order_payment_search.domain.dto.response.ServiceOrderPaymentSearchResponse;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.inject.Inject;
import jakarta.ws.rs.core.Response;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@ApplicationScoped
public class ServiceOrderPaymentSearchService implements ServiceOrderPaymentSearchUseCase {

    private final MessageHelper messageHelper;
    private final RequestValidatorHelper requestValidatorHelper;
    private final BusinessUseCase businessUseCase;

    @Inject
    public ServiceOrderPaymentSearchService(
        MessageHelper messageHelper,
        RequestValidatorHelper requestValidatorHelper,
        BusinessUseCase businessUseCase
    ) {
        this.messageHelper = messageHelper;
        this.requestValidatorHelper = requestValidatorHelper;
        this.businessUseCase = businessUseCase;
    }

    @Override
    public Response execute(
        ServiceOrderPaymentSearchRequest request
    ) {
        log.info("Iniciando ejecucion para la transaccion: {}", request.getPartyId());

        Response response;

        try {
            validate(request);

            ApiResponse<ServiceOrderPaymentSearchResponse> apiResponse = business(request);

            response = messageHelper.handleSuccess(
                apiResponse.getData(),
                apiResponse.getStatusResponse().getStatusCode()
            );
        } catch (HttpStatusCodeException e) {
            log.error("Excepcion HTTP del api de negocio: {} - {}", e.getStatusCode(), e.getErrorCode());
            response = messageHelper.handleException(e);
        } catch (Exception e) {
            log.error("Excepcion generica del api de negocio: {}", e.getMessage());
            response = messageHelper.handleGenericException(e);
        }

        return response;
    }

    private void validate(
        ServiceOrderPaymentSearchRequest request
    ) {
        requestValidatorHelper.validateRequired(request);
        requestValidatorHelper.validateFieldValues(request);
    }

    private ApiResponse<ServiceOrderPaymentSearchResponse> business(
        ServiceOrderPaymentSearchRequest request
    ) {
        log.info("Ejecutando llamada al api de negocio: {}", request.getAppId());
        return businessUseCase.execute(request, ServiceOrderPaymentSearchResponse.class);
    }
}